/**
 * bootstrap-multiselect.js
 * https://github.com/davidstutz/bootstrap-multiselect
 *
 * Copyright 2012 - 2014 David Stutz
 *
 * Dual licensed under the BSD-3-Clause and the Apache License, Version 2.0.
 */
!function(c){if(typeof ko!=="undefined"&&ko.bindingHandlers&&!ko.bindingHandlers.multiselect){ko.bindingHandlers.multiselect={init:function(g,h,i,f,d){var j=i().selectedOptions,e=ko.utils.unwrapObservable(h());c(g).multiselect(e);if(a(j)){j.subscribe(function(m){var k=[],l=[];m.forEach(function(n){switch(n.status){case"added":k.push(n.value);break;case"deleted":l.push(n.value);break}});if(k.length>0){c(g).multiselect("select",k)}if(l.length>0){c(g).multiselect("deselect",l)}},null,"arrayChange")}},update:function(i,j,k,h,d){var g=k().options,f=c(i).data("multiselect"),e=ko.utils.unwrapObservable(j());if(a(g)){g.subscribe(function(l){c(i).multiselect("rebuild")})}if(!f){c(i).multiselect(e)}else{f.updateOriginalOptions()}}}}function a(d){return ko.isObservable(d)&&!(d.destroyAll===undefined)}function b(d,e){this.options=this.mergeOptions(e);this.$select=c(d);this.originalOptions=this.$select.clone()[0].options;this.query="";this.searchTimeout=null;this.options.multiple=this.$select.attr("multiple")==="multiple";this.options.onChange=c.proxy(this.options.onChange,this);this.options.onDropdownShow=c.proxy(this.options.onDropdownShow,this);this.options.onDropdownHide=c.proxy(this.options.onDropdownHide,this);this.buildContainer();this.buildButton();this.buildSelectAll();this.buildDropdown();this.buildDropdownOptions();this.buildFilter();this.updateButtonText();this.updateSelectAll();this.$select.hide().after(this.$container)}b.prototype={defaults:{buttonText:function(e,d){if(e.length===0){return this.nonSelectedText+' <b class="caret"></b>'}else{if(e.length>this.numberDisplayed){return e.length+" "+this.nSelectedText+' <b class="caret"></b>'}else{var f="";e.each(function(){var g=(c(this).attr("label")!==undefined)?c(this).attr("label"):c(this).html();f+=g+", "});return f.substr(0,f.length-2)+' <b class="caret"></b>'}}},buttonTitle:function(e,d){if(e.length===0){return this.nonSelectedText}else{var f="";e.each(function(){f+=c(this).text()+", "});return f.substr(0,f.length-2)}},label:function(d){return c(d).attr("label")||c(d).html()},onChange:function(d,e){},onDropdownShow:function(d){},onDropdownHide:function(d){},buttonClass:"btn btn-default",dropRight:false,selectedClass:"active",buttonWidth:"auto",buttonContainer:'<div class="btn-group" />',maxHeight:false,includeSelectAllOption:false,selectAllText:" Select all",selectAllValue:"multiselect-all",enableFiltering:false,enableCaseInsensitiveFiltering:false,filterPlaceholder:"Search",filterBehavior:"text",preventInputChangeEvent:false,nonSelectedText:"None selected",nSelectedText:"selected",numberDisplayed:3},templates:{button:'<button type="button" class="multiselect dropdown-toggle" data-toggle="dropdown"></button>',ul:'<ul class="multiselect-container dropdown-menu"></ul>',filter:'<div class="input-group"><span class="input-group-addon"><i class="glyphicon glyphicon-search"></i></span><input class="form-control multiselect-search" type="text"></div>',li:'<li><a href="javascript:void(0);"><label></label></a></li>',divider:'<li class="divider"></li>',liGroup:'<li><label class="multiselect-group"></label></li>'},constructor:b,buildContainer:function(){this.$container=c(this.options.buttonContainer);this.$container.on("show.bs.dropdown",this.options.onDropdownShow);this.$container.on("hide.bs.dropdown",this.options.onDropdownHide)},buildButton:function(){this.$button=c(this.templates.button).addClass(this.options.buttonClass);if(this.$select.prop("disabled")){this.disable()}else{this.enable()}if(this.options.buttonWidth&&this.options.buttonWidth!="auto"){this.$button.css({width:this.options.buttonWidth})}var d=this.$select.attr("tabindex");if(d){this.$button.attr("tabindex",d)}this.$container.prepend(this.$button)},buildDropdown:function(){this.$ul=c(this.templates.ul);if(this.options.dropRight){this.$ul.addClass("pull-right")}if(this.options.maxHeight){this.$ul.css({"max-height":this.options.maxHeight+"px","overflow-y":"auto","overflow-x":"hidden"})}this.$container.append(this.$ul)},buildDropdownOptions:function(){this.$select.children().each(c.proxy(function(e,f){var d=c(f).prop("tagName").toLowerCase();if(d==="optgroup"){this.createOptgroup(f)}else{if(d==="option"){if(c(f).data("role")==="divider"){this.createDivider()}else{this.createOptionValue(f)}}}},this));c("li input",this.$ul).on("change",c.proxy(function(e){var k=c(e.target).prop("checked")||false;var l=c(e.target).val()===this.options.selectAllValue;if(this.options.selectedClass){if(k){c(e.target).parents("li").addClass(this.options.selectedClass)}else{c(e.target).parents("li").removeClass(this.options.selectedClass)}}var j=c(e.target).val();var d=this.getOptionByValue(j);var h=c("option",this.$select).not(d);var g=c("input",this.$container).not(c(e.target));if(l){if(this.$select[0][0].value===this.options.selectAllValue){var m=[];var n=c('option[value!="'+this.options.selectAllValue+'"]',this.$select);for(var f=0;f<n.length;f++){if(n[f].value!==this.options.selectAllValue&&this.getInputByValue(n[f].value).is(":visible")){m.push(n[f].value)}}if(k){this.select(m)}else{this.deselect(m)}}}if(k){d.prop("selected",true);if(this.options.multiple){d.prop("selected",true)}else{if(this.options.selectedClass){c(g).parents("li").removeClass(this.options.selectedClass)}c(g).prop("checked",false);h.prop("selected",false);this.$button.click()}if(this.options.selectedClass==="active"){h.parents("a").css("outline","")}}else{d.prop("selected",false)}this.$select.change();this.options.onChange(d,k);this.updateButtonText();this.updateSelectAll();if(this.options.preventInputChangeEvent){return false}},this));c("li a",this.$ul).on("touchstart click",function(h){h.stopPropagation();if(h.shiftKey){var g=c(h.target).prop("checked")||false;if(g){var f=c(h.target).parents("li:last").siblings('li[class="active"]:first');var e=c(h.target).parents("li").index();var d=f.index();if(e>d){c(h.target).parents("li:last").prevUntil(f).each(function(){c(this).find("input:first").prop("checked",true).trigger("change")})}else{c(h.target).parents("li:last").nextUntil(f).each(function(){c(this).find("input:first").prop("checked",true).trigger("change")})}}}c(h.target).blur()});this.$container.on("keydown",c.proxy(function(g){if(c('input[type="text"]',this.$container).is(":focus")){return}if((g.keyCode===9||g.keyCode===27)&&this.$container.hasClass("open")){this.$button.click()}else{var h=c(this.$container).find("li:not(.divider):visible a");if(!h.length){return}var d=h.index(h.filter(":focus"));if(g.keyCode===38&&d>0){d--}else{if(g.keyCode===40&&d<h.length-1){d++}else{if(!~d){d=0}}}var f=h.eq(d);f.focus();if(g.keyCode===32||g.keyCode===13){var e=f.find("input");e.prop("checked",!e.prop("checked"));e.change()}g.stopPropagation();g.preventDefault()}},this))},createOptionValue:function(e){if(c(e).is(":selected")){c(e).prop("selected",true)}var d=this.options.label(e);var i=c(e).val();var h=this.options.multiple?"checkbox":"radio";var j=c(this.templates.li);c("label",j).addClass(h);c("label",j).append('<input type="'+h+'" />');var g=c(e).prop("selected")||false;var f=c("input",j);f.val(i);if(i===this.options.selectAllValue){f.parent().parent().addClass("multiselect-all")}c("label",j).append(" "+d);this.$ul.append(j);if(c(e).is(":disabled")){f.attr("disabled","disabled").prop("disabled",true).parents("li").addClass("disabled")}f.prop("checked",g);if(g&&this.options.selectedClass){f.parents("li").addClass(this.options.selectedClass)}},createDivider:function(e){var d=c(this.templates.divider);this.$ul.append(d)},createOptgroup:function(d){var f=c(d).prop("label");var e=c(this.templates.liGroup);c("label",e).text(f);this.$ul.append(e);if(c(d).is(":disabled")){e.addClass("disabled")}c("option",d).each(c.proxy(function(g,h){this.createOptionValue(h)},this))},buildSelectAll:function(){var d=this.hasSelectAll();if(this.options.includeSelectAllOption&&this.options.multiple&&!d){if(this.options.includeSelectAllDivider){this.$select.prepend('<option value="" disabled="disabled" data-role="divider">')}this.$select.prepend('<option value="'+this.options.selectAllValue+'">'+this.options.selectAllText+"</option>")}},buildFilter:function(){if(this.options.enableFiltering||this.options.enableCaseInsensitiveFiltering){var d=Math.max(this.options.enableFiltering,this.options.enableCaseInsensitiveFiltering);if(this.$select.find("option").length>=d){this.$filter=c(this.templates.filter);c("input",this.$filter).attr("placeholder",this.options.filterPlaceholder);this.$ul.prepend(this.$filter);this.$filter.val(this.query).on("click",function(e){e.stopPropagation()}).on("input keydown",c.proxy(function(e){clearTimeout(this.searchTimeout);this.searchTimeout=this.asyncFunction(c.proxy(function(){if(this.query!==e.target.value){this.query=e.target.value;c.each(c("li",this.$ul),c.proxy(function(g,h){var j=c("input",h).val();var k=c("label",h).text();if(j!==this.options.selectAllValue&&k){var i=false;var f="";if((this.options.filterBehavior==="text"||this.options.filterBehavior==="both")){f=k}if((this.options.filterBehavior==="value"||this.options.filterBehavior==="both")){f=j}if(this.options.enableCaseInsensitiveFiltering&&f.toLowerCase().indexOf(this.query.toLowerCase())>-1){i=true}else{if(f.indexOf(this.query)>-1){i=true}}if(i){c(h).show()}else{c(h).hide()}}},this))}},this),300,this)},this))}}},destroy:function(){this.$container.remove();this.$select.show()},refresh:function(){c("option",this.$select).each(c.proxy(function(d,e){var f=c("li input",this.$ul).filter(function(){return c(this).val()===c(e).val()});if(c(e).is(":selected")){f.prop("checked",true);if(this.options.selectedClass){f.parents("li").addClass(this.options.selectedClass)}}else{f.prop("checked",false);if(this.options.selectedClass){f.parents("li").removeClass(this.options.selectedClass)}}if(c(e).is(":disabled")){f.attr("disabled","disabled").prop("disabled",true).parents("li").addClass("disabled")}else{f.prop("disabled",false).parents("li").removeClass("disabled")}},this));this.updateButtonText();this.updateSelectAll()},select:function(h){if(h&&!c.isArray(h)){h=[h]}for(var d=0;d<h.length;d++){var f=h[d];var g=this.getOptionByValue(f);var e=this.getInputByValue(f);if(this.options.selectedClass){e.parents("li").addClass(this.options.selectedClass)}e.prop("checked",true);g.prop("selected",true)}this.updateButtonText()},clearSelection:function(){var e=this.getSelected();if(e.length){var f=[];for(var d=0;d<e.length;d=d+1){f.push(e[d].value)}this.deselect(f);this.$select.change()}},deselect:function(d){if(d&&!c.isArray(d)){d=[d]}for(var e=0;e<d.length;e++){var g=d[e];var h=this.getOptionByValue(g);var f=this.getInputByValue(g);if(this.options.selectedClass){f.parents("li").removeClass(this.options.selectedClass)}f.prop("checked",false);h.prop("selected",false)}this.updateButtonText()},rebuild:function(){this.$ul.html("");c('option[value="'+this.options.selectAllValue+'"]',this.$select).remove();this.options.multiple=this.$select.attr("multiple")==="multiple";this.buildSelectAll();this.buildDropdownOptions();this.buildFilter();this.updateButtonText();this.updateSelectAll()},dataprovider:function(d){var e="";d.forEach(function(f){e+='<option value="'+f.value+'">'+f.label+"</option>"});this.$select.html(e);this.rebuild()},enable:function(){this.$select.prop("disabled",false);this.$button.prop("disabled",false).removeClass("disabled")},disable:function(){this.$select.prop("disabled",true);this.$button.prop("disabled",true).addClass("disabled")},setOptions:function(d){this.options=this.mergeOptions(d)},mergeOptions:function(d){return c.extend({},this.defaults,this.options,d)},hasSelectAll:function(){return this.$select[0][0]?this.$select[0][0].value===this.options.selectAllValue:false},updateSelectAll:function(){if(this.hasSelectAll()){var d=this.getSelected();if(d.length===c("option:not([data-role=divider])",this.$select).length-1){this.select(this.options.selectAllValue)}else{this.deselect(this.options.selectAllValue)}}},updateButtonText:function(){var d=this.getSelected();c("button",this.$container).html(this.options.buttonText(d,this.$select));c("button",this.$container).attr("title",this.options.buttonTitle(d,this.$select))},getSelected:function(){return c('option[value!="'+this.options.selectAllValue+'"]:selected',this.$select).filter(function(){return c(this).prop("selected")})},getOptionByValue:function(g){var d=c("option",this.$select);var h=g.toString();for(var e=0;e<d.length;e=e+1){var f=d[e];if(f.value==h){return c(f)}}},getInputByValue:function(g){var f=c("li input",this.$ul);var h=g.toString();for(var d=0;d<f.length;d=d+1){var e=f[d];if(e.value==h){return c(e)}}},updateOriginalOptions:function(){this.originalOptions=this.$select.clone()[0].options},asyncFunction:function(g,f,d){var e=Array.prototype.slice.call(arguments,3);return setTimeout(function(){g.apply(d||window,e)},f)}};c.fn.multiselect=function(d,e){return this.each(function(){var g=c(this).data("multiselect");var f=typeof d==="object"&&d;if(!g){g=new b(this,f);c(this).data("multiselect",g)}if(typeof d==="string"){g[d](e);if(d==="destroy"){c(this).data("multiselect",false)}}})};c.fn.multiselect.Constructor=b;c(function(){c("select[data-role=multiselect]").multiselect()})}(window.jQuery);